#> end_cit:buildings/generate
# `(x_offset, y_offset, z_offset, Name, Angle, Rotation)`
#
# Runs an area check, and then places the given structure, and runs any
# configured stacking and post-processing procedures
#
# Returns: -1 if the area check failed, 0 if structure placement failed, 1 
# otherwise

scoreboard players set $ground_check end_cit.data 1
# Area check - fail means reduce a size
$execute unless blocks ^-$(x_check_1) ^ ^-$(z_check_2) ^$(x_check_2) ^ ^$(z_check_1) ~ 255 ~ all run return -2

execute if data storage end_cit:structure structure{ground_check:1b} store result score $ground_check end_cit.data run function end_cit:buildings/technical/ground_check with storage end_cit:structure structure
execute if score $ground_check end_cit.data matches 0 run return -1

$execute store result score $generated end_cit.data rotated $(Angle) 0 run place template $(Name) ^$(x_offset) ^$(y_offset) ^-$(z_offset) $(Rotation)
execute if score $generated end_cit.data matches 0 run return 0

$execute if data storage end_cit:structure structure.PostProcessors rotated $(Angle) 0 positioned ^$(x_offset) ^$(y_offset) ^-$(z_offset) run function end_cit:buildings/post_process
execute if data storage end_cit:structure structure.Stack run function end_cit:buildings/stack/pregen_stack

return 1