#> end_cit:buildings/select
#
# Root building placement function
#
# Reads from the entity tags of the executing entity to determine building type
# and store that in `$size`, to handle building size decay
#
# Reads the `$override_size` scoreboard flag in `end_cit.data` to allow size 
# override for decaying structure levels
#
# Returns: 1 if building placed, 0 if not

execute unless block ~ ~ ~ minecraft:air run return run kill @s[type=minecraft:marker]
execute unless block ~ ~-1 ~ #end_cit:terrain_blocks unless entity @s[tag=arch_generator] run return run kill @s[type=minecraft:marker]
execute if entity @s[tag=arch_generator] unless block ~ ~-1 ~ #end_cit:road_blocks run return run kill @s[type=minecraft:marker]

execute unless score $override_size end_cit.data matches 1 run scoreboard players set $size end_cit.data 0
scoreboard players set $override_size end_cit.data 0
execute if score $size end_cit.data matches 0 if entity @s[tag=small_building_generator] run scoreboard players set $size end_cit.data 1
execute if score $size end_cit.data matches 0 if entity @s[tag=medium_building_generator] run scoreboard players set $size end_cit.data 2
execute if score $size end_cit.data matches 0 if entity @s[tag=large_building_generator] run scoreboard players set $size end_cit.data 3
execute if score $size end_cit.data matches 0 if entity @s[tag=long_building_generator] run scoreboard players set $size end_cit.data 4
execute if score $size end_cit.data matches 0 if entity @s[tag=decor_generator] run scoreboard players set $size end_cit.data 5
execute if score $size end_cit.data matches 0 if entity @s[tag=arch_generator] run scoreboard players set $size end_cit.data 6

execute if score $size end_cit.data matches 0 run return run kill @s

# Randomly select the structure to be placed
execute if score $size end_cit.data matches 1 run data modify storage end_cit:macro root set value "Small"
execute if score $size end_cit.data matches 1 store result score $n end_cit.data run data get storage end_cit:structures Small.Structures

execute if score $size end_cit.data matches 2 run data modify storage end_cit:macro root set value "Medium"
execute if score $size end_cit.data matches 2 store result score $n end_cit.data run data get storage end_cit:structures Medium.Structures

execute if score $size end_cit.data matches 3 run data modify storage end_cit:macro root set value "Large"
execute if score $size end_cit.data matches 3 store result score $n end_cit.data run data get storage end_cit:structures Large.Structures

execute if score $size end_cit.data matches 4 run data modify storage end_cit:macro root set value "Long"
execute if score $size end_cit.data matches 4 store result score $n end_cit.data run data get storage end_cit:structures Long.Structures

execute if score $size end_cit.data matches 5 run data modify storage end_cit:macro root set value "SideDecor"
execute if score $size end_cit.data matches 5 store result score $n end_cit.data run data get storage end_cit:structures SideDecor.Structures

execute if score $size end_cit.data matches 6 run data modify storage end_cit:macro root set value "ArchDecor"
execute if score $size end_cit.data matches 6 store result score $n end_cit.data run data get storage end_cit:structures ArchDecor.Structures


execute unless score $n end_cit.data matches 1.. run return 0
scoreboard players remove $n end_cit.data 1
execute store result storage end_cit:macro n int 1 run scoreboard players get $n end_cit.data
function end_cit:random/select.root.n with storage end_cit:macro

scoreboard players set $n end_cit.data 0
data remove storage end_cit:macro root
data remove storage end_cit:macro n

execute store result score $result end_cit.data run function end_cit:buildings/pregen_building

# Debugging
# execute if score $result end_cit.data matches 1 run setblock ~ 100 ~ gold_block
# execute if score $result end_cit.data matches 1 run setblock ~ 101 ~ minecraft:oak_sign{front_text:{messages:['{"nbt":"x","storage":"end_cit:structure"}','{"nbt":"y","storage":"end_cit:structure"}','{"nbt":"z","storage":"end_cit:structure"}','{"text":""}']}}

# Clear storage
data remove storage end_cit:structure structure

# Failed due to ground area check (tile generation)
execute if score $result end_cit.data matches -1 run return 0

# Generated, or failed to generate due to macro error with structure name
kill @s[type=minecraft:marker]
execute if score $result end_cit.data matches 1 run return 1
execute if score $result end_cit.data matches 0 run return 0

#Decay handling (returned -2)
scoreboard players remove $size end_cit.data 1
scoreboard players set $override_size end_cit.data 1
execute if score $size end_cit.data matches 0 run return -1
return run function end_cit:buildings/select